<?php

//Get Iframe url
function getIframeUrl(){
  $url  = "";
  $authToken = variable_get('pushflew_section/pushflew_group/auth_token') ? variable_get('pushflew_section/pushflew_group/auth_token') : '';
  if ($authToken == null) {
      $url = registerWebsite();
  } else {
      $websiteId = variable_get('pushflew_section/pushflew_group/website_id');
      $url = createURL($authToken, $websiteId);
  }

  return $url;
}

//Register new website
function registerWebsite(){
  global $user, $site_name, $base_url;

  $data = array();
  $data['url'] = "https://app.pushflew.com/registerWebsite";
  $data['user_name'] = $user->name;
  $data['email'] = $user->mail;
  $data['company'] = variable_get('site_name');
  $data['website'] = $base_url;
  $parsedUrl = parse_url($data['website']);
  $host = explode('.', $parsedUrl['host']);
  if(count($host) > 1){ $subdomain = $host[0];}else{$subdomain = '';}
  $data['subdomain'] = $host[0];
  $data['host'] = $_SERVER['REQUEST_SCHEME'];
  $data['timezone'] = $user->timezone;

  $body = array(
            'ownedByUser' => $data['email'],
            'source' => 'drupal',
            'company' => $data['company'],
            'protocol' => $data['host'],
            'website' => $data['website'],
            'subdomain' => $data['subdomain'],
            'timezone' => $data['timezone']
             );

  $frameURL = "";
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $data['url']);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($body));
  curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-type: application/json",));
  $response = curl_exec ($ch);
  

  if(curl_error($ch)){
      echo '[PushFlew]Failed to register Pushflew, try again. <br> Error:' . curl_error($ch);
  }
  else{
     $result = json_decode($response, true);
     saveWebsiteData($result);
     registerLogo($result['websiteId'], $result['auth']);
     $frameURL = createURL($result['auth'], $result['websiteId']);
  }
  curl_close($ch);
  return $frameURL;
}

//saveWebsiteData - callback
function saveWebsiteData($data){
  variable_set('pushflew_section/pushflew_group/auth_token',$data['auth']);
  variable_set('pushflew_section/pushflew_group/website_id',$data['websiteId']);
}

//registerLogo - callback
function registerLogo($siteId, $auth){
  $websiteId = ($siteId ? $siteId : variable_get('pushflew_section/pushflew_group/website_id'));
  $authToken = ($auth ? $auth : variable_get('pushflew_section/pushflew_group/auth_token'));

  if ($websiteId != null && $authToken != null) {
    global $base_url;
    global $theme_key;
    $logo = theme_get_setting('logo', $theme_key);
    variable_set('pushlogo', $logo);
    $url = "https://app.pushflew.com/saveSiteLogo";
    $body = array(
            'websiteId' => $websiteId,
            'logoURL' => $logo,
        );

    $chh = curl_init();
    curl_setopt($chh, CURLOPT_URL, $url);
    curl_setopt($chh, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($chh, CURLOPT_POST, 1);
    curl_setopt($chh, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($chh, CURLOPT_POSTFIELDS, json_encode($body));
    curl_setopt($chh, CURLOPT_HTTPHEADER, array("Content-type: application/json","Authorization:" . $authToken));
    $response = curl_exec ($chh);
    
    if(curl_error($chh)){
      echo '[PushFlew]Failed to register Pushflew, try again. <br> Error:' . curl_error($chh);
    }
    curl_close($chh);

  }
}

//Create iframe URL
function createURL($auth, $websiteId){
  global $user;

  $baseurl = "https://app.pushflew.com/third-party-view";
  $email = $user->mail;
  $url = sprintf("%s?currentuser=%s&websiteId=%s", $baseurl, $email, $websiteId);
  $url = $url . "&auth=" . $auth;
  
  return $url;
}

//get User email
function getUser(){
  global $user;

  $user = $user->name;
  $email = $user->mail;

  return $email;
}


